#include <stdio.h>
#include <unistd.h>
#include <dlfcn.h>
#include "AdvLog.h"
#include "AdvLog.h"
#include "test.h"
#include "Service_API.h"


void show_menu(void)
{
	printf("\n");
	printf("0) Exit \n");
	printf("1) Get Version\n");
	printf("2) Get Status\n");
	printf("3) Get All Service\n");
	printf("4) Get Service's Capability\n");
	printf("Enter your choice: \n");
}


static SV_CODE SVCALL ProcService_Cb( SV_EVENT e, char *ServiceName, void *inData, int dataLen, void *pUserData )
{
	SV_CODE rc = SV_OK;

	printf("Event =%d   ServiceName=%s  Data=%s Len=%d UserData=%d\n", e, ServiceName, inData, inData, dataLen, pUserData );

	return rc;
}



static void*			g_dl_handle       = NULL;   // libAdvPlayer.so載入時的handle
static int const		default_argc = 3;
static char* const default_args[] = { "SNTest", "-d", "3" };

int InitServiceSDKHandler()
{
	
	int rc = 0;
	int i = 0;
	char libpath[MAX_PATH]={0};

	snprintf(libpath,sizeof(libpath),"%s",SERVIVE_SDK_LIB_NAME);

	if( GetServiceSDKLibFn( libpath,&pSVAPI_Interface ) == 0 ) {
		printf("Failed: Get Service Function Point er: \r\n");
		return rc;
	}

	// 2. SN_Manager_Initialize
	if( pSVAPI_Interface->SV_Initialize( &ProcService_Cb, NULL ) != SV_OK ) {
		printf("Failed: to SV_Initialize\r\n");
		return rc;
	}

	rc = 1; 
	printf("Success: Initial Service SDK\r\n");

	return rc;
}

int getText(char *variable, int size){
    if(fgets(variable, sizeof(char) * size, stdin) != NULL ) {
		sscanf(variable, "%[^\n]", variable);
		return strlen(variable);
	}
	return 0;
}


int main(int argc, char *argv[] )
{
	int rc = 0;
	int count = 0;
	int i = 0;
	int done, op;
	char num[12];
	char szParam[512]={0};
	char szResult[2048]={0};

	// AdvLog
	AdvLog_Init();
    if (argc == 1)   // no arguments were passed
    {
       // do things for no arguments
       // usually those variables are set here for a generic flow onwards
       argc = default_argc;
       argv = default_args;
    }
	AdvLog_Arg(argc,argv);

	if( InitServiceSDKHandler() == 0 )
		goto ExitSample;


	done = 0;
	while (! done) {
		show_menu();
		op = -1;
		if( getText(num,12) > 0 ) {
			if(isdigit(num[0])) {
				op = atoi(num);				
			}
		}

        if( op == -1 ) {
			printf("Please input a number\n");
			continue;
		}

		memset(szParam, 0, sizeof(szParam));
		memset(szResult, 0, sizeof(szResult));

		switch ( op ) {
		case 0 :
			{
				goto ExitSample;
			}
			break;
		case 1: // Get Version
			{
				if ( pSVAPI_Interface->SV_GetVersion(szResult, sizeof(szResult)) == SV_OK )
					printf("Service SDK Version: %s\n",  szResult );
				else
					printf("Failed to get Service SDK Version!\n");
			}
			break;
		case 2:  // Get Status
			{
				rc = pSVAPI_Interface->SV_GetServiceStatus( );
			    printf("Status of Service SDK is %d\n",  rc );
			}
			break;
		case 3:  // Query All Service
			{
				if ( pSVAPI_Interface->SV_Query_Service( szResult, sizeof(szResult) ) == SV_OK )
					printf("All of Service Name:   %s\n",  szResult );
				else
					printf("Failed to get all of Service Name!\n");
			}
			break;
		case 4:  // Service's Capability
			{
				printf("Please input Service Name\r\n");
				printf("ex: HDD_PMQ\n");
				if( getText(szParam,sizeof(szParam)) <= 0 ) {
					printf("Input Error\n");
					break;
				}
				if( pSVAPI_Interface->SV_GetCapability( szParam, szResult, sizeof(szResult) ) == SV_OK )
					printf("All of Service Name:   %s\n",  szResult );
				else
					printf("Failed to get %s's capability !\n",szParam);
			}
			break;
		default:
			printf("\nUnknown choice!\n\n");
			continue;
		}
	}

ExitSample:
	pSVAPI_Interface->SV_Uninitialize();


	printf("Exit Service Sample\n");
	return 0;
} 

 
